<template>
  <SinglePane>
    <div class="contractors-title">
      Все контрагенты
    </div>

    <ob-table
      :columns="columns"
      :remote-opt="{
          method: getContractors,
          contentKey: 'participants'
        }"
      :functionalPanel="true"
      :tableLayoutFixed="false"
      data-qa="tendersContractorsTable"
      @select="onSelect"
      is-fixed-header
      :is-functional-sort="false"
      :is-functional-group="false"
    />

    <ob-modal
      ref="contractor-modal"
      size="medium"
      cancelText="Закрыть"
      :isShowControls="true"
      :isReadOnly="true"
      :title="selectedContractor ? selectedContractor.name : ''"
      data-qa="tendersContractorsModal"
    >
      <div class="modal-container">
        <div class="row">
          <div class="col-xs-3 field-names">
            <div>Полное название:</div>
          </div>
          <div class="col-xs-9 field-values">
            <div>{{ selectedContractor.full_name }}</div>
          </div>
        </div>
        <div class="row">
          <div class="col-xs-3 field-names">
            <div>ИНН:</div>
          </div>
          <div class="col-xs-9 field-values">
            <div>{{ selectedContractor.inn }}</div>
          </div>
        </div>
        <div class="row">
          <div class="col-xs-3 field-names">
            <div>КПП:</div>
          </div>
          <div class="col-xs-9 field-values">
            <div>{{ selectedContractor.kpp }}</div>
          </div>
        </div>
        <div class="row">
          <div class="col-xs-3 field-names">
            <div>ОГРН:</div>
          </div>
          <div class="col-xs-9 field-values">
            <div>{{ selectedContractor.ogrn }}</div>
          </div>
        </div>
        <div class="row">
          <div class="col-xs-3 field-names">
            <div>ОКПО:</div>
          </div>
          <div class="col-xs-9 field-values">
            <div>{{ selectedContractor.okpo }}</div>
          </div>
        </div>
        <div class="row">
          <div class="col-xs-3 field-names">
            <div>Юридич. адрес:</div>
          </div>
          <div class="col-xs-9 field-values">
            <div>{{ selectedContractor.address }}</div>
          </div>
        </div>
        <div class="row">
          <div class="col-xs-3 field-names">
            <div>Описание:</div>
          </div>
          <div class="col-xs-9 field-values">
            <div>{{ selectedContractor.description }}</div>
          </div>
        </div>
        <div class="row">
          <div class="col-xs-3 field-names">
            <div>Телефон:</div>
          </div>
          <div class="col-xs-9 field-values">
            <div>{{ selectedContractor.phone }}</div>
          </div>
        </div>
        <div class="row">
          <div class="col-xs-3 field-names">
            <div>Эл. почта:</div>
          </div>
          <div class="col-xs-9 field-values">
            <div>{{ selectedContractor.email }}</div>
          </div>
        </div>
        <div class="row">
          <div class="col-xs-3 field-names">
            <div>Входит в группы:</div>
          </div>
          <div class="col-xs-9">
            <div v-if="selectedContractor.groups && !selectedContractor.groups.length">–</div>
            <div v-else class="bubbles">
              <router-link
                v-for="group in selectedContractor.groups"
                :key="group.uuid"
                :to="`/tenders-contractor-groups/${group.uuid}`"
                target="_blank"
              >{{ group.title }}</router-link>
            </div>
          </div>
        </div>
        <router-link
          class="modal-link"
          :to="selectedContractor ? `/tenders-contractors/${selectedContractor.uuid}` : ''"
        >
          Перейти в подробную карточку
        </router-link>
      </div>
    </ob-modal>
  </SinglePane>
</template>

<script>
import api from '@/api';

import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import ObTable    from 'common-components/src/obComponents/obTable';
import ObModal    from 'common-components/src/obComponents/obModal';

export default {
  name: 'tenders-index',
  components: {
    SinglePane,
    ObTable,
    ObModal
  },
  data() {
    return {
      selectedContractor: {},

      columns: [
        {
          title: 'Название контрагента',
          key: 'shortTitle'
        },
        {
          title: 'Инн',
          key: 'inn'
        },
        {
          title: 'Телефон',
          key: 'phone'
        },
        {
          title: 'Эл. почта',
          key: 'email'
        },
        {
          title: 'Описание',
          key: 'description',
          html: data => data.description || '–'
        },
        {
          title: 'Юридический адрес',
          key: 'legalAddress'
        }
      ]
    };
  },
  methods: {
    // 👂 Events
    async onSelect(e) {
      const { data } = await api.tendersContractors.getParticipantsShortCard(e.uuid);

      const contractor = {
        uuid       : data.uuid,
        full_name  : data.fullTitle,
        inn        : data.inn          || '–',
        kpp        : data.kpp          || '–',
        ogrn       : data.ogrn         || '–',
        okpo       : data.okpo         || '–',
        address    : data.legalAddress || '–',
        description: data.description  || '–',
        phone      : data.phone        || '–',
        email      : data.email        || '–',
        groups     : data.groups
      };

      this.selectedContractor = contractor;
      this.$refs['contractor-modal'].open();
    },

    async getContractors(params) {
      return await api.tenders.getContractors(params)
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";
@import "~common-components/src/assets/style/ob-style";

.contractors-title {
  @include font-mixin(20px, 28px, 700, $tendersContractorsPage-contractors_title, 0.4px);

  padding: 20px;
}

.field-names {
  @include font-mixin(14px, 20px, 400, $color-grey-span);
}

.field-values {
  @include font-mixin(14px, 20px, 400, $color-text-base);
}

.bubbles {
  display: flex;
  align-items: flex-start;
  flex-wrap: wrap;

  > a {
    @include font-mixin(14px, 18px, 400, $color-text-base);
    position: relative;
    top: -3px;
    padding: 5px 12px;
    border-radius: 100px;
    background: $lavender;
    margin-right: 10px;
    margin-bottom: 10px;
    word-break: break-word;
    cursor: pointer;
    text-decoration: none;

    &:last-child {
      margin-right: 0;
    }
  }
}

.modal-link {
  @include font-mixin(14px, 18px, 400, $color-blue-navy-blue, 0.4px);
  margin-top: 20px;
}
</style>
